﻿using System;
using System.Drawing;
using System.Collections.Generic;
using Ranorex;
using TechTalk.SpecFlow;
using System.Windows.Forms;

namespace com.edgewords.ranorex.pom.helpers
{

    public class BaseTest
    {
        protected WebDocument dom;


        public void StartBrowser(String url, String browser)
        {
            CloseAllBrowsers(); //In case prev. test failed & left browser open
            Host.Local.OpenBrowser(Globals.GLOBAL_BASE_URL + url, browser,true,false);
            dom = "/dom[@domain='" + Globals.GLOBAL_BASE_URL + "']";
            dom.WaitForDocumentLoaded();
        }

        public void CloseBrowser()
        {
            dom.Close();
            Delay.Seconds(2);
        }

        public void CloseAllBrowsers()
        {
            IList<WebDocument> wdList = Host.Local.Find<WebDocument>("/dom");
            foreach (WebDocument wd in wdList)
            {
                wd.EnsureVisible();
                if (wd.Visible)
                {
                    try
                    {
                        wd.Close();
                    }
                    catch (Ranorex.ActionFailedException e)
                    {
                        Report.Warn("failed to close browser window/tab: " + e.Message);
                    }
                }
            }
            Delay.Milliseconds(500);
        }
    }
}
